<?php
/**
 * Date: 2023/1/6
 * Time: 01:51
 */

class WC_Gateway_Wooshpay_vm extends WC_Payment_Gateway_CC
{
	private $fileCharset = "UTF-8";

    private $currencyMinUnit = array(
        'AED' => 2,
        'AFN' => 2,
        'ALL' => 2,
        'AMD' => 2,
        'ANG' => 2,
        'AOA' => 2,
        'ARS' => 2,
        'AUD' => 2,
        'AWG' => 2,
        'AZN' => 2,
        'BAM' => 2,
        'BBD' => 2,
        'BDT' => 2,
        'BGN' => 2,
        'BHD' => 3,
        'BIF' => 0,
        'BMD' => 2,
        'BND' => 2,
        'BOB' => 2,
        'BOV' => 2,
        'BRL' => 2,
        'BSD' => 2,
        'BTN' => 2,
        'BWP' => 2,
        'BYN' => 2,
        'BZD' => 2,
        'CAD' => 2,
        'CDF' => 2,
        'CHE' => 2,
        'CHF' => 2,
        'CHW' => 2,
        'CLF' => 4,
        'CLP' => 0,
        'CNY' => 2,
        'COP' => 2,
        'COU' => 2,
        'CRC' => 2,
        'CUC' => 2,
        'CUP' => 2,
        'CVE' => 2,
        'CZK' => 2,
        'DJF' => 0,
        'DKK' => 2,
        'DOP' => 2,
        'DZD' => 2,
        'EGP' => 2,
        'ERN' => 2,
        'ETB' => 2,
        'EUR' => 2,
        'FJD' => 2,
        'FKP' => 2,
        'GBP' => 2,
        'GEL' => 2,
        'GHS' => 2,
        'GIP' => 2,
        'GMD' => 2,
        'GNF' => 0,
        'GTQ' => 2,
        'GYD' => 2,
        'HKD' => 2,
        'HNL' => 2,
        'HRK' => 2,
        'HTG' => 2,
        'HUF' => 2,
        'IDR' => 2,
        'ILS' => 2,
        'INR' => 2,
        'IQD' => 3,
        'IRR' => 2,
        'ISK' => 0,
        'JMD' => 2,
        'JOD' => 3,
        'JPY' => 0,
        'KES' => 2,
        'KGS' => 2,
        'KHR' => 2,
        'KMF' => 0,
        'KPW' => 2,
        'KRW' => 0,
        'KWD' => 3,
        'KYD' => 2,
        'KZT' => 2,
        'LAK' => 2,
        'LBP' => 2,
        'LKR' => 2,
        'LRD' => 2,
        'LSL' => 2,
        'LYD' => 3,
        'MAD' => 2,
        'MDL' => 2,
        'MGA' => 2,
        'MKD' => 2,
        'MMK' => 2,
        'MNT' => 2,
        'MOP' => 2,
        'MRU' => 2,
        'MUR' => 2,
        'MVR' => 2,
        'MWK' => 2,
        'MXN' => 2,
        'MXV' => 2,
        'MYR' => 2,
        'MZN' => 2,
        'NAD' => 2,
        'NGN' => 2,
        'NIO' => 2,
        'NOK' => 2,
        'NPR' => 2,
        'NZD' => 2,
        'OMR' => 3,
        'PAB' => 2,
        'PEN' => 2,
        'PGK' => 2,
        'PHP' => 2,
        'PKR' => 2,
        'PLN' => 2,
        'PYG' => 0,
        'QAR' => 2,
        'RON' => 2,
        'RSD' => 2,
        'RUB' => 2,
        'RWF' => 0,
        'SAR' => 2,
        'SBD' => 2,
        'SCR' => 2,
        'SDG' => 2,
        'SEK' => 2,
        'SGD' => 2,
        'SHP' => 2,
        'SLL' => 2,
        'SOS' => 2,
        'SRD' => 2,
        'SSP' => 2,
        'STN' => 2,
        'SVC' => 2,
        'SYP' => 2,
        'SZL' => 2,
        'THB' => 2,
        'TJS' => 2,
        'TMT' => 2,
        'TND' => 3,
        'TOP' => 2,
        'TRY' => 2,
        'TTD' => 2,
        'TWD' => 2,
        'TZS' => 2,
        'UAH' => 2,
        'UGX' => 0,
        'USD' => 2,
        'USN' => 2,
        'UYI' => 0,
        'UYU' => 2,
        'UYW' => 4,
        'UZS' => 2,
        'VED' => 2,
        'VES' => 2,
        'VND' => 0,
        'VUV' => 0,
        'WST' => 2,
        'XAF' => 0,
        'XCD' => 2,
        'XOF' => 0,
        'XPF' => 0,
        'YER' => 2,
        'ZAR' => 2,
        'ZMW' => 2,
        'ZWL' => 2
    );

    /**
     * WC_Gateway_wooshpay constructor.
     */
    public function __construct()
    {
        $this->id = "wooshpay";
//        $this->icon = WC_DPluspay_vm_URL . "/assets/imgs/vm.png";
        $this->has_fields = true;
        $this->method_title = "WooshPay";
        $this->method_description = "WooshPay";

        $this->init_form_fields();
        $this->init_settings();

        $this->enabled = $this->get_option("enabled");
        $this->title = $this->get_option("title");
        $this->ipoolid = $this->get_option("ipoolid");
        $this->appid = $this->get_option("appid");
        $this->appsecret = $this->get_option("appsecret");
        $this->mode = $this->get_option("mode");
        $this->sk_live = $this->get_option("sk_live");
        $this->pk_live = $this->get_option("pk_live");
        $this->pk_test = $this->get_option("pk_test");
        $this->sk_test = $this->get_option("sk_test");
        $this->gatewayUrl = $this->get_option("gatewayUrl",'');

        global $aop;
        $aop = new AopClient_vm();

        $aop->gatewayUrl = $this->gatewayUrl;
        $aop->appId = $this->appid;
        $aop->rsaPrivateKey = $this->appsecret; #应用私钥
        $aop->sk_live = $this->sk_live; #应用私钥
        $aop->pk_test = $this->pk_test; #应用私钥
        $aop->pk_live = $this->pk_live; #应用私钥
        $aop->postCharset = "utf-8";
        $aop->format = "json";

        add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));

        //添加hook钩子，设置回调函数
        add_action('woocommerce_api_returnpage', [$this, 'return_page_handle']);
        add_action('woocommerce_api_vm-notify', [$this, 'notify_vm']);
    }

    /**
     * Payment form on checkout page
     */
    public function payment_fields() {
        ob_start();

        echo '<div
			id="wooshpay-payment-data"
			data-currency="' . esc_attr( strtolower( get_woocommerce_currency() ) ) . '"
		>';

        $this->elements_form();

        do_action( 'wc_vm_payment_fields_wooshpay', $this->id );

        echo '</div>';

        ob_end_flush();
    }
    public function elements_form() {
        ?>
        <fieldset id="wc-<?php echo esc_attr( $this->id ); ?>-cc-form" class="wc-credit-card-form wc-payment-form" style="background:transparent;">
            <!-- wooshpay -->
            <div id="payment-app">
                <div>
                    <!--Wooshpay Will Inject the Payment Element At Here-->
                </div>
            </div>
            <style>
                #payment-app iframe {
                    width: 100%;
                    outline: none;
                    border: none;
                    height: 300px;
                }
            </style>

            <?php
                if($this->mode == 'test') {
                ?>
                    <script src='https://jstest.wooshpay.com/v1/wooshpay.js'></script>
            <?php
                } else if($this->mode == 'live') {
            ?>
                    <script src='https://js.wooshpay.com/v1/wooshpay.js'></script>
            <?php
                }
            ?>

            <script>
                console.info('wooshpay checkout rendering...');
                // 获取app表单
                 wooshpay_div = document.getElementById('payment-app')
                // 创建wooshpay  publishableKey
                 wooshpay = Wooshpay('<?php
                     if($this->mode == 'test') {
                         echo esc_attr( $this->pk_test );
                     } else if($this->mode == 'live') {
                         echo esc_attr( $this->pk_live );
                     }

                     ?>'/* publishable ke */, {
                    locale: 'en' // 目前支持en与cn
                })
                // pi_1549666816303824896
                 elements = wooshpay.elements({
                    clientSecret: 'not_needed',
                    // clientSecret: 交易意向单编号
                    appearance: {
                        // 银行卡图标列表
                        bankIcons: [
                            'https://js.wooshpay.com/v1/public/visa-729c05c240c4bdb47b03ac81d9945bfe.svg',
                            'https://js.wooshpay.com/v1/public/mastercard-4d8844094130711885b5e41b28c9848f.svg'
                        ]
                    }
                })
                // 创建Element实例
                elements.create('payment', {billingDetails:'never'})
                // 挂载收银台页面
                elements.mount(wooshpay_div)
                //
                window.onConfirmMethod = async function(e,confirmparams){
                    // e.preventDefault()
                    // 确认支付，失败返回错误信息，支付成功自动跳转return_url
                    if( !(elements && ( elements.clientSecret && elements.wooshpay && elements.wooshpay.publishableKey )) ) {
                        console.error('clientSecret or publishableKey is required');
                    }
                    //  传参==>confirmparams
                    // {
                    //     billing_details: {
                    //     address: {
                    //     city: "Greater London",
                    //     country: "GB",
                    //     line1: "231 Bolton Ave",
                    //     line2: "Apmt #101",
                    //     state: "England",
                    //     postal_code: "E14 9XN"
                    //   },
                    //     email: "labo44@126.com",
                    //     name: "Manuel Romero Gamero",
                    //     phone: "7467799999"
                    //        },
                    //    }
                    try {
                        const response =  await wooshpay.confirmPaymentMethod({elements,confirmParams:confirmparams})
                        return response // 支付失败
                    } catch (e) {
                        console.log(e,'lys');
                    } finally {
                    }
                }
            </script>
            <!-- wooshpay_end -->

            <div class="clear"></div>
        </fieldset>
        <?php

        wp_register_script( 'woocommerce_wooshpay', plugins_url( 'assets/js/wooshpay_form.js', WC_wooshpay_vm_URL ), [ ], '', true );
        wp_enqueue_script( 'woocommerce_wooshpay' );
    }


    function notify_vm()
    {
        $content = trim(file_get_contents("php://input"));
        $this->log("wooshpay webhook callback:". $content);
        //decode the incoming RAW post data from JSON.
        $event = json_decode($content, true);

        if (!$this->check_signature($event["created"])) {
            echo "validation failed";
            die;
        }

        if ($event["type"] == "payment_intent.succeeded") {//支付成功
            $order_id = $event["data"]["object"]["merchant_order_id"];
            $this->log("order_id:$order_id");
            $order = new WC_Order($order_id);
            $this->log("order status:". $order->get_status());
            $this->log("order total:". $order->get_total());

            if ($order->needs_payment()) {
                $order->payment_complete();
                $this->log("needs_payment is true, payment status changed");
                echo "process ok. payment status changed";
            } else {
                $this->log("needs_payment is false, webhook callback ignored");
                echo "process ok. webhook callback ignored";
            }
        } else {
            echo $event["type"]." igored";
        }

        die;
    }

    function check_signature($event_time) {
        //Wooshpay-Signature:t=1492774577,v1=6fdfb9c357542b8ee07277f5fca2c6f728bae2dce9be2f91412f4de922c1bae4
        if (!isset($_SERVER['HTTP_WOOSHPAY_SIGNATURE'])) {
            echo "fail to validate";
            return false;
        }
        $signature = $_SERVER['HTTP_WOOSHPAY_SIGNATURE'];
        $this->log($signature);

        $sig_kv = explode(',', $signature);
        $timestamp = explode('=', $sig_kv[0])[1];

        if ($timestamp == $event_time) {
            $this->log("timestamp check ok");
            return true;
        }
        return false;
    }


    function validateCC($cc_num, $type)
    {
        $verified = false;
        if ($type == "American") {
            $pattern = "/^([34|37]{2})([0-9]{13})$/";//American Express
            if (preg_match($pattern, $cc_num)) {
                $verified = true;
            } else {
                $verified = false;
            }


        } elseif ($type == "Dinners") {
            $pattern = "/^([30|36|38]{2})([0-9]{12})$/";//Diner's Club
            if (preg_match($pattern, $cc_num)) {
                $verified = true;
            } else {
                $verified = false;
            }


        } elseif ($type == "Discover") {
            $pattern = "/^([6011]{4})([0-9]{12})$/";//Discover Card
            if (preg_match($pattern, $cc_num)) {
                $verified = true;
            } else {
                $verified = false;
            }


        } elseif ($type == "Master") {
            $pattern = "/^([51|52|53|54|55]{2})([0-9]{14})$/";//Mastercard
            if (preg_match($pattern, $cc_num)) {
                $verified = true;
            } else {
                $verified = false;
            }


        } elseif ($type == "Visa") {
            $pattern = "/^([4]{1})([0-9]{12,15})$/";//Visa
            if (preg_match($pattern, $cc_num)) {
                $verified = true;
            } else {
                $verified = false;
            }

        }
        return $verified;
    }

    function validateCvc($cvc)
    {
        $verified = false;
        $pattern = "/^([0-9]{3})$/";
        if (preg_match($pattern, $cvc)) {
            return true;;
        } else {
            return false;
        }
    }
            /**
     * 配置列表项
     */
    function init_form_fields()
    {
        $this->form_fields = array(
                //            'enabled' => array(
                //                'title' => __('Enable/Disable', 'woocommerce'),
                //                'type' => 'checkbox',
                //                'lable' => __('Enable payment', 'woocommerce'),
                //                'default' => 'yes'
                //            ),
                 'title' => array(
                     'title' => __('Title', 'woocommerce'),
                     'type' => 'text',
                     'description' => __('The title that users will see during settlement', 'woocommerce'),
                     'default' => __('Card and E-Wallets', 'woocommerce'),
                     'desc_tip' => true,
                     'css' => 'width:400px'
                 ),
                 'mode' => array(
                     'title' => __('Mode', 'woocommerce'),
                     'type' => 'select',
                 //                'default' => '',
                 //                'description' => __('mode', 'woocommerce'),
                     'options' => array( 'test' => 'test', 'live' => 'live')
                 //                'css' => 'width:40px'
                 ),
                 'pk_test' => array(
                     'title' => __('Test publishable key', 'woocommerce'),
                     'type' => 'text',
                     'default' => '',
                     'placeholder'=>'pk_test_XXXXXX',
                     'description' => __('You can obtain the test publishable key from the Wooshpay dashboard.', 'woocommerce'),
                     'css' => 'width:800px'
                 ),
                 'sk_test' => array(
                     'title' => __('Test secret key', 'woocommerce'),
                     'type' => 'text',
                     'placeholder'=>'sk_test_XXXXXX',
                     'default' => '',
                     'description' => __('You can obtain the test secret key from the Wooshpay dashboard.', 'woocommerce'),
                     'css' => 'width:800px'
                 ),
                 'pk_live' => array(
                     'title' => __('Publishable key', 'woocommerce'),
                     'type' => 'text',
                     'default' => '',
                     'placeholder'=>'pk_live_XXXXXX',
                     'description' => __('You can obtain the publishable key from the Wooshpay dashboard.', 'woocommerce'),
                     'css' => 'width:800px'
                 ),
                 'sk_live' => array(
                     'title' => __('Secret key', 'woocommerce'),
                     'type' => 'text',
                     'default' => '',
                     'placeholder'=>'sk_live_XXXXXX',
                     'description' => __('You can obtain the secret key from the Wooshpay dashboard.', 'woocommerce'),
                     'css' => 'width:800px'
                 )
            );
    }

    /**
     * Logger 辅助功能
     *
     * @param $message
     */
    public function log($message,$name="")
    {
        file_put_contents("vm_call_".$name.".log", date('Y-m-d H:i:s',time()).' '.$message.PHP_EOL, FILE_APPEND);
    }
    public function validate_fields()
    {
//        if (empty($_POST['Card_Number'])) {
//            wc_add_notice('Card Number is required!', 'error');
//            return false;
//        }
//        if (empty($_POST['Expiry_Date'])) {
//            wc_add_notice('Expiry Date is required,year+month!', 'error');
//            return false;
//        }
//        if (empty($_POST['CVC_Code'])) {
//            wc_add_notice('Security code is required!', 'error');
//            return false;
//        }
//        if (empty($_POST['Payer_Name'])) {
//            wc_add_notice('Cardholder name is required!', 'error');
//            return false;
//        }
        return true;
    }

    function toAPIAmount($amount, $currency)
    {
        $minUnit = $this->currencyMinUnit[$currency];
        return bcmul((double)$amount,pow(10, $minUnit));
    }
    /**
     * 支付方法
     * @param int $order_id
     * @return array
     */
    function process_payment($order_id)
    {
//        $order = wc_get_order(48);
//        $this->log($order->get_meta('_wooshpay_payment_intent_id'));

        global $woocommerce;
        global $aop;

        if (!is_dir('tmp/')) {
            mkdir('tmp/', 0777);
        }
        $file_name = 'tmp/' . md5($order_id) . ".php";
        $file = fopen($file_name, "w");

        $order = new WC_Order($order_id);
//         $return_url = $this->get_return_url($order);

        if ( version_compare( WC_VERSION, '2.0', '<' ) ) {
            $return_url = site_url(). '?wc-api=returnpage&order_id='. $order_id;
        } else {
            $return_url = site_url(). '/wc-api/returnpage?order_id='. $order_id;
        }

        $notify_url =   str_replace('https:', 'http:',WC()->api_request_url('vm-notify') );

        $this->log("return_url");
        $this->log($return_url);
        $this->log("notify_url");
        $this->log($notify_url);
//        $cardtype = "master";
//         if($this->validateCC($_POST['Card_Number'],"Visa"))
//         {
//             $cardtype = "visa";
//         }else if($this->validateCC($_POST['Card_Number'],"Master"))
//         {
//             $cardtype = "master";
//         }else {
//             wc_add_notice("Your card number is incorrect.", 'error');
//             return false;
//         }
//
//         if (!$this->validateCvc($_POST['CVC_Code'])) {
//             wc_add_notice("Your CVC is incorrect.", 'error');
//             return false;
//         }

//        $this->log($notify_url,"order");
        $this->log("order details:");
        $this->log($order);

        $total_amount = $order->get_total();
        $order_title = $this->get_order_title($order);

        //请求参数
        $post_data = [];
        $post_data["orgno"]=$aop->appId;//商户
        $post_data["total_fee"]=$total_amount * 100;
//        $post_data['cardtype'] =$cardtype;

        $post_data["returnurl"]=$return_url;
        $post_data["backurl"] = $notify_url;

        $order_no = $this->get_order_number($order_id);
        $order_no2  = "Y".date("YmdHis").'E'.$order_no;

//        $post_data["out_trade_no"]=$order_no2;
        //        $post_data["channel"]="overseaspay";
//        $post_data["payername"]= 'MAI' . rand(10000,99999);//$order->data['billing']['first_name'] . $order->data['billing']['last_name'];
//        $post_data["productlist"]='[{"productname":"'. $order_title .'","price":"'. $total_amount .'","count":"1","platformurl":"'.plugin_dir_url(__FILE__).'","categoryid":"20"}]';

        $payment_method_id = $_POST['wooshpay_pm_id'];
        $this->log("form param wooshpay_pm_id:".$payment_method_id);

//        $expiry_date = $_POST['Expiry_Date'];
//        $expire_year = "20".substr($expiry_date,0,2);
//        $expire_month = substr($expiry_date,2,2);

        $data = array(
                "amount" => $this->toAPIAmount($order->get_total(), strtoupper($order->get_currency())),
                "currency" => $order->get_currency(),
                "confirm"=>true,
                "payment_method_options" => array("card" => array ("request_three_d_secure"=> "auto","capture_method"=> "automatic")),
//                "payment_method_data" => array(
//                                            "ip"=>$order->get_customer_ip_address(),
//                                            "user_agent"=> $order->get_customer_user_agent(),
//                                            "referer"=> "",//FIXME
//                                            "payment_user_agent" => "server_to_server"
//                                         ),
                "payment_method" => $payment_method_id,
                "description"=> "product description",
                "merchant_user_id"=> $order->get_customer_id(),
                "merchant_order_id"=> $order_id,
                "return_url"=>$return_url
        );

		if ( method_exists( $order, 'get_shipping_postcode' ) && ! empty( $order->get_shipping_postcode() ) ) {
			$data['shipping'] = array(
                    "address"=> array(
                        "line1"=> $order->get_shipping_address_1(),
                        "line2"=> $order->get_shipping_address_2(),
                        "city"=> $order->get_shipping_city(),
                        "state"=> $order->get_shipping_state(),
                        "country"=> $order->get_shipping_country(),
                        "postal_code"=> $order->get_shipping_postcode()
                    ),
                    "name"=> $order->get_shipping_first_name()." ".$order->get_shipping_last_name(),
                    "phone"=> $order->get_shipping_phone()
                );
		}


        $postdata = json_encode($data);
        $this->log($postdata);
        // 1. 调用发生通讯异常 2. 解析response
        try {
            $response = $this->submitToST($postdata);

            $payment_response_obj = json_decode($response, true);

            if (!empty($payment_response_obj["id"])) { // 订单创建成功
                $order->update_meta_data( '_wooshpay_payment_intent_id', $payment_response_obj["id"]);
                $order->save();

                if ($payment_response_obj["status"] == "succeeded") {//支付成功
                    fwrite($file, $response);
                    fclose($file);

                    $msg = 'Customers are paying by wooshpay';
                    $order->add_order_note($msg);
                    $order->payment_complete();

                    $woocommerce->cart->empty_cart();      //清空购物车
                    //update_post_meta($order_id, '_gateway_payment_url', $return_url);

                    $this->log($order_no2,"order");
                    // 返重定向到支付表单
                    return array(
                        'result' => 'success',
                        'redirect' => $return_url
                    );
                } else if ($payment_response_obj["status"] == "requires_action") { //需要auth
                    if (is_string($payment_response_obj["next_action"])) {
                        $next_action_obj = json_decode($payment_response_obj["next_action"], true);
                    } else {
                        $next_action_obj = $payment_response_obj["next_action"];
                    }

                    $redirect_url = "";
                    if (!empty($next_action_obj["ddc_redirect"])) {
                        $redirect_url = $next_action_obj["ddc_redirect"]["url"];
                    } else if (!empty($next_action_obj["challenge_redirect"])) {
                        $redirect_url = $next_action_obj["challenge_redirect"]["url"];
                    }

                    $this->log("auth redirect_url".$redirect_url);

                    return array(
                        'result' => 'success',
                        'redirect' => $redirect_url
                    );
                } else if ($payment_response_obj["status"] == "requires_payment_method") {
                    $last_payment_error = $payment_response_obj["last_payment_error"];
                    if (is_string($last_payment_error)) {
                        $last_payment_error_obj = json_decode($last_payment_error, true);
                    } else {
                        $last_payment_error_obj = $last_payment_error;
                    }
                    $this->log("last_payment_error_obj:");
                    $this->log($last_payment_error_obj);

                    wc_add_notice($last_payment_error_obj["code"].': '.$last_payment_error_obj["message"], 'error');

                    return array(
                        'result' => 'fail',
                        'redirect' => $this->get_return_url($order)
                    );
                }
            } else if  (!empty($payment_response_obj["type"]) && strpos($payment_response_obj["type"], "error") !== false) {
                //接口返回错误
                wc_add_notice($payment_response_obj["message"], 'error');
                return array(
                    'result' => 'fail',
                    'redirect' => $this->get_return_url($order)
                );
            }
        } catch (Exception $e) {
            wc_add_notice("errcode:{$e->getCode()},errmsg:{$e->getMessage()}", 'error');
            return array(
                'result' => 'fail',
                'redirect' => $this->get_return_url($order)
            );
        }
    }
    
    /* 拼接 sign */
    function sign($post_data,$signStr)
    {
        $post_datastr = '';
        //使用URL键值对的格式（即key1=value1&key2=value2…）拼接成字符串stringA
        foreach ($post_data AS $name => $value) {
            if (!is_array($value)) {
                if ($value != null && $value != '') {
                    $post_datastr = $post_datastr . $name . '=' . $value . '&';
                }
            }
        }
        $tmpArr = explode('&', trim($post_datastr, '&'));
        //参数名ASCII码从小到大排序（字典序）
        sort($tmpArr, SORT_STRING);
        $tmpStr = implode('&', $tmpArr);

        //拼接API密钥
        $tmpStr = $tmpStr . '&key=' . $signStr;

        return strtoupper(md5($tmpStr));
    }

    private function get_order_title($order)
    {
        $order_id = $order->get_id();
        $title = "#{$order_id}";
        $order_items = $order->get_items();  // 获取这个订单中包含的商品
        if ($order_items) {
            foreach ($order_items as $item_id => $item) {
                $title .= "|{$item['name']}";
            }
        }
        $limit = 250;
        $title = mb_strimwidth($title, 0, $limit, "utf-8");
        return $title;

    }

    /**
     * @param $arr
     * @return mixed
     */
    public function check_response($arr)
    {
        $originalSign = $arr['sign'];
        unset($arr['sign']);
        $stringSignTemp = $this->sign($arr,$this->appsecret);

        return ($originalSign == $stringSignTemp) ? true : false;
    }
	
	/**
	 * 转换字符集编码
	 * @param $data
	 * @param $targetCharset
	 * @return string
	 */
	function characet($data, $targetCharset) {
		
		if (!empty($data)) {
			$fileType = $this->fileCharset;
			if (strcasecmp($fileType, $targetCharset) != 0) {
				$data = mb_convert_encoding($data, $targetCharset, $fileType);
				//				$data = iconv($fileType, $targetCharset.'//IGNORE', $data);
			}
		}


		return $data;
	}
	
	/**
	 * 校验$value是否非空
	 *  if not set ,return true;
	 *    if is null , return true;
	 **/
	protected function checkEmpty($value) {
		if (!isset($value))
			return true;
		if ($value === null)
			return true;
		if (trim($value) === "")
			return true;

		return false;
	}
	
    /**
     * 检查参数对不对
     * @param $arr
     * @return bool
     */
    public function check_data($arr)
    {
        // 商户订单号
        $out_trade_no = $arr['out_trade_no'];
        $order = new WC_Order($out_trade_no);
        // 不是商户系统中的订单号
        if (!$order) {
            return false;
        }
        // 订单金额
        $total_amount = $arr['total_amount'];
        // 订单金额有问题
        if ($total_amount != $order->get_total()) {
            return false;
        }
        $seller_id = $arr['seller_id'];
        if ($seller_id != $this->pid) {
            return false;
        }
        // APPID
        $app_id = $arr['app_id'];
        if ($app_id != $this->appid) {
            return false;
        }

        return true;
    }

    function return_page_handle()
    {
        $queries = array();
        parse_str($_SERVER['QUERY_STRING'], $queries);
        $order_id = $queries['order_id'];
		$this->log("order id:".$order_id);

        $order = wc_get_order($order_id);
        $pi_id = $order->get_meta('_wooshpay_payment_intent_id');

        try {
            $response = $this->retrieve_payment_intent($pi_id);;
            $payment_response_obj = json_decode($response, true);

            if (!empty($payment_response_obj["id"])) {
                if ($payment_response_obj["status"] == "succeeded") {//支付成功
                    $order->payment_complete();
                    WC()->cart->empty_cart();      //清空购物车
                    wp_redirect($this->get_return_url($order));
                } else if ($payment_response_obj["status"] == "requires_payment_method") {
					$last_payment_error = $payment_response_obj["last_payment_error"];
					if ($last_payment_error == NULL) {
					    wc_add_notice('Payment processing', 'notice');
                    	wp_redirect(WC()->cart->get_checkout_url());
					} else {
                        if (is_string($last_payment_error)) {
                            $last_payment_error_obj = json_decode($last_payment_error, true);
                        } else {
                            $last_payment_error_obj = $last_payment_error;
                        }
                        wc_add_notice($last_payment_error_obj["code"].': '.$last_payment_error_obj["message"], 'error');
                        wp_redirect(WC()->cart->get_checkout_url());
					}
// 					exit;
                }
            } else if  (!empty($payment_response_obj["type"]) && strpos($payment_response_obj["type"], "error") !== false) {
                //接口返回错误
                wc_add_notice($payment_response_obj["message"], 'error');
                return array(
                    'result' => 'fail',
                    'redirect' => $this->get_return_url($order)
                );
            }
        } catch (Exception $e) {
            wc_add_notice("errcode:{$e->getCode()},errmsg:{$e->getMessage()}", 'error');
            return array(
                'result' => 'fail',
                'redirect' => $this->get_return_url($order)
            );
        }
       exit;
    }

    protected function retrieve_payment_intent($pi_id) {
        $curl = curl_init();

       $acct_key = "";
       $gateway_url = "";
       if($this->mode == 'test') {
           $acct_key=$this->sk_test;
           $gateway_url = 'https://apitest.wooshpay.com/v1/payment_intents';
       } else if($this->mode == 'live') {
           $acct_key=$this->sk_live;
           $gateway_url = 'https://api.wooshpay.com/v1/payment_intents';
       }

       curl_setopt_array($curl, array(
             CURLOPT_URL => $gateway_url.'/'.$pi_id,
             CURLOPT_RETURNTRANSFER => true,
             CURLOPT_ENCODING => '',
             CURLOPT_MAXREDIRS => 10,
             CURLOPT_TIMEOUT => 0,
             CURLOPT_FOLLOWLOCATION => true,
             CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
             CURLOPT_CUSTOMREQUEST => 'GET',
             CURLOPT_HTTPHEADER => array(
               'Content-Type: application/json'
             ),
             CURLOPT_USERPWD => $acct_key . ":",
           ));

           $this->log(json_encode(curl_getinfo($curl)));
           $response = curl_exec($curl);
           $this->log("curl response:");
           $this->log($response);

           curl_close($curl);
        return $response;
    }

    protected function submitToST($postFields = null) {
        $this->log("after adding settings");
        $curl = curl_init();

        $acct_key = "";
        $gateway_url = "";
        if($this->mode == 'test') {
            $acct_key=$this->sk_test;
            $gateway_url = 'https://apitest.wooshpay.com/v1/payment_intents';
        } else if($this->mode == 'live') {
            $acct_key=$this->sk_live;
            $gateway_url = 'https://api.wooshpay.com/v1/payment_intents';
        }

        curl_setopt_array($curl, array(
              CURLOPT_URL => $gateway_url,
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => '',
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 0,
              CURLOPT_FOLLOWLOCATION => true,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => 'POST',
              CURLOPT_POSTFIELDS =>$postFields,
              CURLOPT_HTTPHEADER => array(
//                'Idempotency-Key: 123456789',//FIXME
//                'Authorization: Basic c2tfdGVzdF9OVEUxT0RRME5EUXpOek0yTmpJek1EWXpNRFF4T2tSaE5EZElkMnBQYVZKdFZGZEdTRFZVUlhVMU5WUXpUakUyTmpZMU9UVTVOVFUxTURrPTo=',
                'Content-Type: application/json'
              ),
              CURLOPT_USERPWD => $acct_key . ":",
            ));

            $this->log("curl_getinfo:");
            $this->log(json_encode(curl_getinfo($curl)));
            $response = curl_exec($curl);
            $this->log("curl response:");
            $this->log($response);

            curl_close($curl);
    		return $response;
    	}
    
	protected function curl($url, $postFields = null) {
		$ch = curl_init();
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_URL, $url);//请求地址
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Accept-Language:en;"));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postFields);
        $data = curl_exec($ch);
		return $data;
	}

	protected function getMillisecond() {
		list($s1, $s2) = explode(' ', microtime());
		return (float)sprintf('%.0f', (floatval($s1) + floatval($s2)) * 1000);
	}

    public function get_order_number($order_id)
    {
        return ltrim($order_id, '#');
    }
}